// This is an easy representation of the world map using mercator projection.
// The idea for this type of storage of map data is copied from the WorldMap
// component of the Grommet project found here:
// https://github.com/grommet/grommet/blob/master/src/js/components/WorldMap/WorldMap.js
//
// The idea is that every continent is stored with an area of [y, x, height, width] and
// then a dot-matrix of rows, where each element in the dot-array has an origin point and
// a counter of columns in the row. The format is [y origin, x origin, count].
const MAP_DATA = {
  area: [0, 0, 84, 127], // 94
  continents: [
    {
      name: 'North America',
      area: [0, 0, 55, 57],
      dots: [
        [0, 51, 2],
        [1, 48, 6],
        [2, 35, 5],
        [2, 47, 8],
        [3, 34, 8],
        [3, 47, 9],
        [4, 33, 9],
        [4, 43, 12],
        [5, 31, 10],
        [5, 42, 14],
        [5, 57, 2],
        [6, 32, 9],
        [6, 42, 17],
        [7, 30, 1],
        [7, 32, 8],
        [7, 41, 17],
        [8, 30, 2],
        [8, 33, 6],
        [8, 40, 18],
        [9, 30, 9],
        [9, 40, 17],
        [10, 30, 8],
        [10, 41, 16],
        [11, 27, 1],
        [11, 31, 6],
        [11, 39, 18],
        [12, 24, 1],
        [12, 27, 3],
        [12, 31, 6],
        [12, 38, 19],
        [13, 23, 2],
        [13, 33, 3],
        [13, 39, 18],
        [14, 21, 2],
        [14, 32, 4],
        [14, 39, 18],
        [15, 21, 2],
        [15, 27, 2],
        [15, 30, 6],
        [15, 39, 18],
        [16, 22, 2],
        [16, 25, 1],
        [16, 27, 2],
        [16, 31, 1],
        [16, 34, 1],
        [16, 43, 14],
        [17, 23, 3],
        [17, 28, 1],
        [17, 30, 6],
        [17, 43, 14],
        [18, 20, 1],
        [18, 44, 13],
        [19, 20, 3],
        [19, 26, 1],
        [19, 28, 1],
        [19, 30, 2],
        [19, 33, 3],
        [19, 44, 12],
        [20, 19, 8],
        [20, 28, 3],
        [20, 32, 5],
        [20, 44, 12],
        [21, 20, 7],
        [21, 28, 3],
        [21, 32, 6],
        [21, 44, 12],
        [22, 8, 1],
        [22, 22, 5],
        [22, 30, 1],
        [22, 32, 7],
        [22, 45, 11],
        [23, 6, 7],
        [23, 15, 4],
        [23, 22, 6],
        [23, 30, 1],
        [23, 33, 7],
        [23, 44, 11],
        [24, 5, 23],
        [24, 29, 3],
        [24, 34, 1],
        [24, 37, 3],
        [24, 46, 9],
        [25, 0, 1],
        [25, 5, 18],
        [25, 25, 2],
        [25, 29, 6],
        [25, 37, 4],
        [25, 45, 8],
        [26, 0, 3],
        [26, 5, 30],
        [26, 38, 4],
        [26, 45, 7],
        [27, 0, 3],
        [27, 4, 30],
        [27, 37, 5],
        [27, 45, 6],
        [28, 5, 30],
        [28, 36, 5],
        [28, 45, 5],
        [29, 5, 27],
        [29, 33, 1],
        [29, 38, 3],
        [29, 46, 3],
        [30, 4, 27],
        [30, 36, 2],
        [30, 46, 3],
        [31, 4, 26],
        [31, 36, 3],
        [31, 47, 2],
        [32, 5, 5],
        [32, 14, 16],
        [32, 36, 3],
        [33, 8, 2],
        [33, 15, 16],
        [33, 36, 6],
        [34, 7, 1],
        [34, 16, 17],
        [34, 37, 5],
        [35, 17, 17],
        [35, 36, 7],
        [36, 17, 27],
        [37, 18, 26],
        [38, 19, 22],
        [38, 43, 1],
        [39, 20, 12],
        [39, 34, 7],
        [39, 43, 2],
        [40, 20, 22],
        [41, 20, 19],
        [42, 20, 19],
        [43, 20, 18],
        [44, 20, 17],
        [45, 21, 16],
        [46, 22, 14],
        [47, 23, 12],
        [48, 23, 7],
        [48, 34, 1],
        [49, 25, 4],
        [50, 26, 3],
        [50, 36, 1],
        [51, 26, 3],
        [51, 32, 1],
        [52, 28, 5],
        [53, 31, 4],
        [54, 33, 1],
        [55, 34, 1],
      ],
    },
    {
      name: 'South America',
      area: [55, 35, 82, 39],
      dots: [
        [55, 37, 5],
        [56, 36, 8],
        [57, 36, 10],
        [58, 36, 11],
        [59, 35, 13],
        [60, 35, 16],
        [61, 35, 16],
        [62, 36, 15],
        [63, 37, 13],
        [64, 37, 13],
        [65, 39, 11],
        [66, 39, 10],
        [67, 39, 9],
        [68, 39, 8],
        [69, 39, 7],
        [70, 38, 8],
        [71, 38, 7],
        [72, 38, 6],
        [73, 38, 5],
        [74, 38, 4],
        [75, 38, 3],
        [76, 37, 4],
        [77, 37, 3],
        [78, 37, 3],
        [79, 37, 3],
        [80, 37, 2],
        [81, 38, 2],
        [82, 39, 1],
      ],
    },
    {
      name: 'Europe',
      area: [9, 56, 44, 72],
      dots: [
        [9, 70, 3],
        [10, 68, 3],
        [10, 72, 1],
        [11, 68, 3],
        [12, 69, 3],
        [13, 69, 1],
        [14, 69, 1],
        [23, 71, 4],
        [24, 70, 5],
        [25, 69, 6],
        [26, 69, 6],
        [27, 56, 3],
        [27, 68, 7],
        [28, 56, 3],
        [28, 68, 3],
        [28, 72, 3],
        [29, 67, 4],
        [29, 72, 3],
        [30, 66, 4],
        [30, 71, 3],
        [31, 66, 4],
        [31, 71, 2],
        [32, 66, 5],
        [33, 62, 1],
        [33, 68, 2],
        [34, 62, 1],
        [34, 67, 3],
        [35, 61, 3],
        [35, 66, 2],
        [35, 70, 3],
        [36, 60, 5],
        [36, 66, 7],
        [37, 62, 2],
        [37, 65, 7],
        [38, 64, 9],
        [39, 63, 12],
        [40, 63, 12],
        [41, 63, 3],
        [41, 67, 2],
        [41, 70, 4],
        [42, 61, 4],
        [42, 68, 1],
        [42, 71, 3],
        [43, 61, 3],
        [43, 71, 1],
        [44, 61, 2],
      ],
    },
    {
      name: 'Asia',
      area: [7, 71, 61, 121],
      dots: [
        [7, 83, 1],
        [7, 85, 2],
        [7, 97, 1],
        [8, 80, 1],
        [8, 84, 1],
        [8, 97, 1],
        [9, 96, 3],
        [10, 97, 2],
        [11, 98, 3],
        [12, 99, 2],
        [14, 100, 2],
        [15, 87, 1],
        [15, 99, 5],
        [16, 85, 2],
        [16, 97, 7],
        [16, 113, 2],
        [17, 84, 2],
        [17, 95, 9],
        [17, 113, 5],
        [18, 84, 1],
        [18, 94, 9],
        [18, 108, 2],
        [18, 117, 1],
        [19, 83, 1],
        [19, 88, 2],
        [19, 93, 17],
        [19, 113, 2],
        [20, 83, 1],
        [20, 88, 22],
        [20, 113, 4],
        [21, 82, 2],
        [21, 88, 22],
        [21, 112, 6],
        [22, 83, 1],
        [22, 87, 35],
        [23, 88, 36],
        [24, 75, 2],
        [24, 83, 44],
        [25, 75, 3],
        [25, 79, 48],
        [26, 75, 3],
        [26, 79, 48],
        [27, 75, 1],
        [27, 78, 49],
        [28, 75, 52],
        [29, 75, 52],
        [30, 74, 52],
        [31, 73, 46],
        [31, 121, 4],
        [32, 72, 47],
        [32, 121, 1],
        [33, 71, 43],
        [33, 120, 2],
        [34, 71, 42],
        [34, 119, 3],
        [35, 73, 40],
        [35, 119, 2],
        [36, 73, 42],
        [36, 119, 1],
        [37, 72, 43],
        [38, 73, 42],
        [39, 75, 38],
        [40, 75, 38],
        [41, 78, 3],
        [41, 82, 30],
        [41, 114, 1],
        [42, 75, 1],
        [42, 78, 3],
        [42, 83, 27],
        [43, 73, 9],
        [43, 83, 26],
        [44, 74, 36],
        [44, 113, 1],
        [45, 77, 30],
        [45, 109, 1],
        [45, 111, 3],
        [46, 76, 31],
        [46, 110, 1],
        [47, 75, 33],
        [48, 76, 5],
        [48, 82, 25],
        [49, 77, 5],
        [49, 85, 21],
        [50, 78, 7],
        [50, 88, 17],
        [51, 78, 7],
        [51, 89, 6],
        [51, 97, 5],
        [52, 79, 5],
        [52, 90, 3],
        [52, 97, 5],
        [53, 79, 3],
        [53, 90, 2],
        [53, 98, 4],
        [54, 91, 1],
        [54, 100, 3],
        [55, 91, 1],
        [56, 99, 1],
        [56, 108, 1],
        [57, 98, 3],
        [57, 104, 2],
        [58, 99, 2],
        [58, 103, 3],
        [59, 100, 1],
        [59, 103, 2],
        [60, 100, 1],
        [60, 112, 3],
        [61, 103, 1],
        [61, 113, 3],
      ],
    },
    {
      name: 'Australia',
      area: [63, 104, 77, 126],
      dots: [
        [63, 110, 2],
        [63, 114, 1],
        [64, 108, 4],
        [64, 114, 2],
        [65, 107, 9],
        [66, 105, 12],
        [67, 104, 14],
        [68, 104, 14],
        [69, 105, 13],
        [70, 105, 13],
        [71, 105, 3],
        [71, 112, 6],
        [72, 113, 4],
        [73, 114, 2],
        [73, 126, 1],
        [74, 126, 1],
        [75, 115, 1],
        [75, 125, 1],
        [76, 124, 1],
        [77, 123, 1],
      ],
    },
    {
      name: 'Africa',
      area: [45, 58, 71, 80],
      dots: [
        [45, 63, 5],
        [46, 61, 7],
        [47, 60, 15],
        [48, 59, 17],
        [49, 59, 17],
        [50, 58, 18],
        [51, 58, 19],
        [52, 58, 20],
        [53, 58, 20],
        [54, 58, 21],
        [55, 59, 23],
        [56, 60, 21],
        [57, 67, 14],
        [58, 67, 13],
        [59, 67, 12],
        [60, 68, 10],
        [61, 68, 10],
        [62, 69, 9],
        [63, 69, 9],
        [64, 68, 10],
        [64, 80, 2],
        [65, 68, 9],
        [65, 80, 1],
        [66, 69, 7],
        [66, 79, 2],
        [67, 69, 7],
        [67, 79, 2],
        [68, 69, 7],
        [69, 70, 5],
        [70, 70, 5],
        [71, 70, 4],
      ],
    },
  ],
};

const EQUATOR_Y = 64;
const WIDTH = 127;

const X_OFFSET = 0;
const Y_OFFSET = -5;

/**
 * Convert a geo-coordinate to the point on the map
 * @param {*} geo
 * @returns
 */
function geoToLocation(geo) {
  const [latitude, longitude] = geo;

  // scale the longitude and get the x-value
  const lonScaled = longitude;
  const x = Math.round((lonScaled + 180) * (WIDTH / 360));

  const latScaled = latitude;
  const latRadians = (latScaled * Math.PI) / 180;

  // get the y-Value
  const mercN = Math.log(Math.tan(Math.PI / 4 + latRadians / 2));
  const y = Math.round(EQUATOR_Y - (WIDTH * mercN) / (2 * Math.PI));

  return [x + X_OFFSET, y + Y_OFFSET];
}

module.exports = {
  data: MAP_DATA,
  geoToLocation,
};
